from tkinter import *
from tkinter import messagebox

global string
global subStr
global stepCounter
global cur
vert = 200
vertFirst = 300
hor = 1000
global even

def makeSufTable(str):
	res = [0] * len(str)
	for i in range(len(str) - 1, -1, -1):
		ind = str.find(str[i:])
		if ind == -1 or ind == i:
			res[i] = len(str)
		else:
		#!
			res[i] = i - ind
	
	return res

def help():
	messagebox.showwarning("",
	"""
	Кнопка "Задать" - задать новые строку и подстроку.
	"Следующий шаг ->" - программа сделает один алгоритмический шаг вперёд.
	"<- Предыдущий шаг" - программа вернётся на шаг назад.
	________________________________________________________________________
	
	Верхнее изображение (появляется тогда, когда строки заданы) показывает, какие символы сравниваются сейчас, а также относительное положение строки и подстроки.
	Нижнее изображение: слева - таблица стоп-символов (см. описание алгоритма), где * - любой символ, справа - таблица суффиксов (см. туда же) (в столбцах подразумевается суффикс, состоящий из текущего символа и всех предыдущих).
	________________________________________________________________________
	
	При нахождении подстроки или при достижении конца строки (при отсутствии подстроки в данной строке) Вы будете уведомлены лично.
	
	""")
	
def win():
	messagebox.showwarning("Уведомление", "Подстрока найдена!")
	#processLabel.config(text = "Substing was found!")
	nextButton.config(state = "disabled")

def fail():
	messagebox.showwarning("Уведомление", "Поиск дошёл до конца и не обнаружил искомой подстроки в заданной строке.")
	#processLabel.config(text = "Substing was not found!")
	nextButton.config(state = "disabled")
	
def BoyerMoore():
	global pos
	global dis
	global even
	
	for i in range(len(string)):
		mainCanvas.itemconfig(strImage[i], fill = "white")
		
	for i in range(len(subStr)):
		mainCanvas.delete(subStrImage[i])
		mainCanvas.delete(subStrText[i])
		subStrImage[i] = mainCanvas.create_rectangle(leftspace + size * (pos - len(subStr) + i + 1), upspace + size, leftspace + size * ((pos - len(subStr) + i) + 2), upspace + 2 * size, 
			width = 2)
		subStrText[i] = mainCanvas.create_text(leftspace + size * (pos - len(subStr) + i + 1) + size / 2, upspace + size * 3 / 2, font = ("Helvectica", str(int(size / 2))), 
			text = subStr[i])
	
	for i in range(len(subStr) - dis, len(subStr)):
		mainCanvas.itemconfig(subStrImage[i], fill = "green")
		mainCanvas.itemconfig(strImage[pos - (len(subStr) - i) + 1], fill = "green")
	
	if even == 0:
		mainCanvas.itemconfig(subStrImage[len(subStr) - dis - 1], fill = "yellow")
		mainCanvas.itemconfig(strImage[pos - dis], fill = "yellow")
		processLabel.config(text = "Сравниваем символы '" + string[pos - dis] + "' и '" + subStr[-1 - dis] + "'.")
	else:
		if string[pos - dis] == subStr[- dis - 1]:
			processLabel.config(text = "Они одинаковы. Переходим к сравнению символов, расположенных левее (либо говорим о том, что подстрока найдена)")
			mainCanvas.itemconfig(subStrImage[len(subStr) - dis - 1], fill = "green")
			mainCanvas.itemconfig(strImage[pos - dis], fill = "green")
			dis += 1
			if dis == len(subStr):
				win()
		else:
			mainCanvas.itemconfig(subStrImage[len(subStr) - dis - 1], fill = "red")
			mainCanvas.itemconfig(strImage[pos - dis], fill = "red")
			if string[pos-dis] not in table.keys():
				symb = "*"
			else:
				symb = string[pos-dis]
			move = max(table[symb] - dis, sufTable[- dis - 1])
			processLabel.config(text = "Они разные. Эвристика стоп-символа указывает на сдвиг на " + str(table[symb] - dis) + " (" + str(table[symb]) + " - " + str(dis)+ "), эвристика совпавшего суффикса показывает сдвиг на " + str(sufTable[- dis - 1]) + ". Выбираем максимум - сдвиг на " + str(move) + ".")
			if pos + move > len(string) - 1:
				fail()
				posTable.append(len(string) - pos)
				disTable.append(dis)
				dis = 0
				pos = len(string)
				even = (even + 1) % 2
				return
			else:
				pos += move
				posTable[pos] = move
				disTable[pos] = dis
				dis = 0
		
	if not (pos == len(subStr) - 1 and  dis == 0 and even == 0):
		prevButton.config(state = "active")
	else:
		prevButton.config(state = "disabled")
		
	
	even = (even + 1) % 2
		

def nextStep():
	BoyerMoore()

def prevStep():
	global dis
	global pos
	global posTable
	global disTable
	global even
	
	nextButton.config(state = "active")
	
	if dis > 0:
		dis -= 1
	else:
		dis = disTable[pos]
		pos -= posTable[pos]
		
			
	BoyerMoore()

def setNewStrings(event):
	global isFound
	isFound = 0
	
	global even
	even = 0
	
	global string
	global subStr
	string = strEntry.get()
	subStr = subStrEntry.get()
	#prevButton.config(state = "active")
	nextButton.config(state = "active")
	
	
	global posTable
	global disTable
	
	posTable = [0] * len(string)
	disTable = [0] * len(string)
	
	global table
	global sufTable
	table = dict()
	
	sufTable = makeSufTable(subStr)
	sufTable.append(1)
	
	for i in range(len(subStr) - 1, -1, -1):
		if not subStr[i] in table.keys():
			table[subStr[i]] = len(subStr) - i - 1
	
	i = 0
	
	table["*"] = len(subStr)
	
	global upspace
	global leftspace
	global betweenspace
	global size
	
	upspace = 50
	leftspace = 50
	betweenspace = 50
	size = min((hor / 2 - leftspace - betweenspace / 2) // len(table), (vert - 2 * upspace) / 2)
	
	auxCanvas.delete(ALL)
	mainCanvas.delete(ALL)
	
	for el in table.items():
		auxCanvas.create_rectangle(leftspace + size * i, vert / 2 - size, leftspace + size * (i + 1), vert / 2, width = 2)
		auxCanvas.create_text(leftspace + size * i + size / 2, vert / 2 - size / 2, font = ("Helvectica", str(int(size / 2))), text = el[0])
		auxCanvas.create_rectangle(leftspace + size * i, vert / 2, leftspace + size * (i + 1), vert / 2 + size, width = 2)
		auxCanvas.create_text(leftspace + size * i + size / 2, vert / 2 + size / 2, font = ("Helvectica", str(int(size / 2))), text = el[1])
		i += 1
	
	size = min((hor / 2 - leftspace - betweenspace / 2) // len(subStr), (vert - 2 * upspace) / 2)
	
	for i in range(len(subStr)):
		auxCanvas.create_rectangle(hor / 2 + betweenspace / 2 + size * i, vert / 2 - size, hor / 2 + betweenspace / 2 + size * (i + 1), vert / 2, width = 2)
		auxCanvas.create_text(hor / 2 + betweenspace / 2 + size * i + size / 2, vert / 2 - size / 2, font = ("Helvectica", str(int(size / 2))), text = subStr[i])
		auxCanvas.create_rectangle(hor / 2 + betweenspace / 2 + size * i, vert / 2, hor / 2 + betweenspace / 2 + size * (i + 1), vert / 2 + size, width = 2)
		auxCanvas.create_text(hor / 2 + betweenspace / 2 + size * i + size / 2, vert / 2 + size / 2, font = ("Helvectica", str(int(size / 2))), text = sufTable[i])
	
	
	global strImage
	global subStrImage
	global subStrText

	
	strImage = [0] * len(string)
	subStrImage = [0] * len(subStr)
	subStrText = [0] * len(subStr)
	
	size = min((hor - 2 * leftspace) / len(string), vertFirst - 2 * upspace)
	
	for i in range(len(string)):
		strImage[i] = mainCanvas.create_rectangle(leftspace + size * i, upspace, leftspace + size * (i + 1), upspace + size, width = 2)
		mainCanvas.create_text(leftspace + size * i + size / 2, upspace + size / 2, font = ("Helvectica", str(int(size / 2))), text = string[i])
	
	#
	global pos
	global dis	
	pos = len(subStr) - 1
	dis = 0
	
	for i in range(len(subStr)):
		subStrImage[i] = mainCanvas.create_rectangle(leftspace + size * i, upspace + size, leftspace + size * (i + 1), upspace + 2 * size, width = 2)
		subStrText[i] = mainCanvas.create_text(leftspace + size * i + size / 2, upspace + size * 3 / 2, font = ("Helvectica", str(int(size / 2))), text = subStr[i])
	
	BoyerMoore()
	

app = Tk()
app.title("Boyer-Moore by Andrej Zhuravlev")
app.resizable(0, 0)
app.geometry(str(hor) + "x650")

mainCanvas = Canvas(width = hor, height = vertFirst, bg = "white")
mainCanvas.grid(row = 0, column = 0, columnspan = 4)

auxCanvas = Canvas(width = hor, height = vert, bg = "white")
auxCanvas.grid(row = 1, column = 0, columnspan = 4)

strEntry = Entry(width = 100)
strEntry.insert(0, "коллоловклолкколкол")
strEntry.grid(row = 2, column = 0, columnspan = 2)

strLabel = Label(text = "Изначальная строка, в которой производится поиск.")
strLabel.grid(row = 3, column = 0, columnspan = 2)

subStrEntry = Entry()
subStrEntry.insert(0, "колокол")
subStrEntry.grid(row = 2, column = 2, sticky = W+E+S+N)

subStrLabel = Label(text = "Подстрока, поиск которой производится.")
subStrLabel.grid(row = 3, column = 2)

prevButton = Button(app, text = "<- Предыдущий шаг", state = "disabled")
prevButton.grid(row = 4, column = 0, sticky = E+S+N, pady = 10)
#prevButton.bind("<Button-1>", prevStep)
prevButton.config(command = prevStep)

nextButton = Button(app, text = "Следующий шаг  ->", state = "disabled")
nextButton.grid(row = 4, column = 1, sticky = W+S+N, pady = 10)
#nextButton.bind("<Button-1>", nextStep)
nextButton.config(command = nextStep)

setButton = Button(app, text = "Задать", width = 10)
setButton.grid(row = 4, column = 2, sticky = S+N, pady = 10)
setButton.bind("<Button-1>", setNewStrings)


processLabel = Label(text = "Нажмите <<Задать>> для начала работы.", bg = "white")
processLabel.grid(row = 5, column = 0, columnspan = 4, sticky = W+S+N+E, pady = 20)

menubar = Menu(app)
menubar.add_command(label="Помощь!", command=help)

app.config(menu=menubar)

app.mainloop()